import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

//my imports
import java.io.*;
import java.util.*;

class JTAWriter extends PrintStream {
    JTextArea jta;
    public JTAWriter(JTextArea jta) {
        super(System.err);
        this.jta = jta;
    }
    public void print(String s) {
        jta.append(s);
    }
    public void println(String s) {
        jta.append(s + "\n");
    }
    public void write(int b) {
        StringBuffer sb = new StringBuffer();
        sb.append((char)b);
        jta.append(sb.toString());
    }
    public void write(byte[] b) {
        String s = new String(b);
        jta.append(s);
    }
    public void write(byte[] b,
                      int off,
                      int len) {
        String s = new String(b, off, len);
        jta.append(s);
    }
}

public class Interface extends JFrame {
    private JPanel contentPane;
    private JMenuBar jMenuBar1 = new JMenuBar();
    private JMenu jMenuFile = new JMenu();
    private JMenuItem jMenuFileExit = new JMenuItem();
    private JMenu jMenuHelp = new JMenu();
    private JMenuItem jMenuHelpAbout = new JMenuItem();
    private JToolBar jToolBar = new JToolBar();
    private JButton jbtnOpen = new JButton();
    private JButton jbtnSave = new JButton();
    private ImageIcon image1;
    private ImageIcon image2;
    private ImageIcon image3;
    private JLabel statusBar = new JLabel();
    private BorderLayout borderLayout1 = new BorderLayout();
    private TitledBorder titledBorder1;
    private JSplitPane jspOutput = new JSplitPane();
    private JButton jbtnSubgraph = new JButton();
    private JSplitPane jspCategories = new JSplitPane();
    private JButton jbtnMerge = new JButton();
    private JScrollPane jscrGraphs = new JScrollPane();
    private JScrollPane jscrCategories = new JScrollPane();
    private JTextArea jtaBib = new JTextArea();
    private JTextArea jtaErrors = new JTextArea();
    private JButton jbtnList = new JButton();
    private JTextField jtfQuery = new JTextField();
    private JButton jbtnRDF = new JButton();
    private JButton jbtnDOT = new JButton();
    private JMenuItem jMenuFileOpen = new JMenuItem();
    private JMenuItem jMenuFileSave = new JMenuItem();
    private JMenu jMenuOutput = new JMenu();
    private JCheckBoxMenuItem jMenuEndnote7 = new JCheckBoxMenuItem();
    private JMenuItem jMenuEndnote9 = new JMenuItem();
    private JMenuItem jMenuClustDOT = new JMenuItem();
    private JButton jbtnGenerate = new JButton();
    private JMenu jMenuInput = new JMenu();
    private JMenuItem jMenuInputGenerate = new JMenuItem();
    private JMenuItem jMenuInputKeyword = new JMenuItem();
    private JMenuItem jMenuInputCopy = new JMenuItem();
    private JSplitPane jspKeywords = new JSplitPane();
    private JScrollPane jscrKeywords = new JScrollPane();
    private JTextArea jtaOutput = new JTextArea();
    private JScrollPane jscrOutput = new JScrollPane();
    private JList jlstKeywords = new JList();

    /**Construct the frame*/
    public Interface() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            jbInit();
            myInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    /**Component initialization*/
    private void jbInit() throws Exception  {
        image1 = new ImageIcon(Interface.class.getResource("openFile.gif"));
        image2 = new ImageIcon(Interface.class.getResource("closeFile.gif"));
        image3 = new ImageIcon(Interface.class.getResource("help.gif"));
        //setIconImage(Toolkit.getDefaultToolkit().createImage(Interface.class.getResource("[Your Icon]")));
        contentPane = (JPanel) this.getContentPane();
        titledBorder1 = new TitledBorder("");
        contentPane.setLayout(borderLayout1);
        this.setSize(new Dimension(627, 446));
        this.setTitle("BibTeX to EndNote XML Converter");
        statusBar.setBorder(BorderFactory.createEtchedBorder());
        statusBar.setText(" ");
        jMenuFile.setText("File");
        jMenuFileExit.setText("Exit");
        jMenuFileExit.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileExit_actionPerformed(e);
            }
                      });
        jMenuOutput.setText("Options");
        jMenuEndnote7.setText("Enable Endnote 9+ features (BETA)");
        jMenuEndnote7.setSelected(BibEndnote.NEWSTYLETAGS);
        jMenuEndnote7.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                BibEndnote.NEWSTYLETAGS=jMenuEndnote7.isSelected();
            }
                      });

        jMenuHelp.setText("Help");
        jMenuHelpAbout.setText("About");
        jMenuHelpAbout.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuHelpAbout_actionPerformed(e);
            }
        });
        jbtnOpen.setIcon(image1);
        jbtnOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jbtnOpen_actionPerformed(e);
            }
        });
        jbtnOpen.setMinimumSize(new Dimension(30, 27));
        jbtnOpen.setPreferredSize(new Dimension(30, 27));
        jbtnOpen.setToolTipText("Open BibTeX");
        jbtnSave.setIcon(image2);
        jbtnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jbtnSave_actionPerformed(e);
            }
        });
        jbtnSave.setMinimumSize(new Dimension(30, 27));
        jbtnSave.setPreferredSize(new Dimension(30, 27));
        jbtnSave.setToolTipText("Save EndNote XML");


        jtfQuery.setMinimumSize(new Dimension(40, 21));
        jMenuFileOpen.setText("Open BibTeX (.bib) file...");
        jMenuFileOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jbtnOpen_actionPerformed(e);
            }
        });
        jMenuFileSave.setText("Save EndNote XML...");
        jMenuFileSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jbtnSave_actionPerformed(e);
            }
        });

        jToolBar.add(jbtnOpen);
        jToolBar.add(jbtnSave);
        jMenuOutput.add(jMenuEndnote7);
        jMenuHelp.add(jMenuHelpAbout);
        jMenuBar1.add(jMenuFile);
        jMenuBar1.add(jMenuOutput);
        jMenuBar1.add(jMenuHelp);
        this.setJMenuBar(jMenuBar1);
        contentPane.add(jToolBar, BorderLayout.NORTH);
        contentPane.add(statusBar, BorderLayout.SOUTH);
        contentPane.add(jspOutput, BorderLayout.CENTER);
        jspOutput.add(jscrKeywords, JSplitPane.LEFT);
        //jspCategories.add(jscrGraphs, JSplitPane.TOP);
        //jscrGraphs.getViewport().add(jtaBib, null);
        //jspCategories.add(jscrCategories, JSplitPane.BOTTOM);
        jspOutput.add(jscrOutput, JSplitPane.RIGHT);
        //jspKeywords.add(jscrKeywords, JSplitPane.TOP);
        jscrKeywords.getViewport().add(jtaErrors, null);
        //jspKeywords.add(jscrOutput, JSplitPane.BOTTOM);
        jscrOutput.getViewport().add(jtaOutput, null);
        //jscrCategories.getViewport().add(jtaErrors, null);
        jMenuFile.add(jMenuFileOpen);
        jMenuFile.add(jMenuFileSave);
        jMenuFile.addSeparator();
        jMenuFile.add(jMenuFileExit);

        jspOutput.setDividerLocation(400);
        //jspCategories.setDividerLocation(200);
        jspKeywords.setDividerLocation(0);

        System.setErr(new JTAWriter(jtaErrors));

    }
    /**File | Exit action performed*/
    public void jMenuFileExit_actionPerformed(ActionEvent e) {
        System.exit(0);
    }
    /**Help | About action performed*/
    public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
        Interface_AboutBox dlg = new Interface_AboutBox(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        dlg.setModal(true);
        dlg.show();
    }
    /**Overridden so we can exit when window is closed*/
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            jMenuFileExit_actionPerformed(null);
        }
    }

    void jbtnOpen_actionPerformed(ActionEvent e) {
        jfc.setFileFilter(bibFilter);
        jfc.showOpenDialog(this);
        if (jfc.getSelectedFile() != null && jfc.getSelectedFile().exists()) {
            try {
                statusBar.setText("Converting BibTeX...");
                StringWriter sw = new StringWriter();

                BibEndnote.doFile(jfc.getSelectedFile(), new PrintWriter(sw));
                jtaOutput.setText(sw.toString());
                statusBar.setText("Converting BibTeX... Done.");

            } catch (Exception ee) {
                jop.showMessageDialog(this, ee.toString(), "Error", jop.ERROR_MESSAGE);
                System.err.println(ee);
                ee.printStackTrace();
                statusBar.setText("Error During Conversion");
            }
        }
//	System.out.println(graphs.keySet());
    }

    JOptionPane jop = new JOptionPane();
    JFileChooser jfc = new JFileChooser();

    private ExtFilter bibFilter = new ExtFilter(".bib", "BibTeX Database (*.bib)");
    private ExtFilter xmlFilter = new ExtFilter(".xml", "(EndNote) XML files (*.xml)");
    private ExtFilter allFilter = new ExtFilter("", "All Files (*.*)");

    private void saveGraph(File file) throws IOException {
        jtaOutput.write(new FileWriter(file));
    }

    private void myInit() throws IOException {
    }


    void jbtnSave_actionPerformed(ActionEvent e) {
        jfc.setFileFilter(xmlFilter);
        jfc.setSelectedFile(new File("endnote.xml"));
        jfc.showSaveDialog(this);
        if (jfc.getSelectedFile() != null) {
            try {
                statusBar.setText("Saving EndNote XML...");
                saveGraph(jfc.getSelectedFile());
                statusBar.setText("Saving EndNote... Done.");
                jop.showMessageDialog(this, "Now Import into EndNote using the \"EndNote Generated XML\" option", "Success", jop.INFORMATION_MESSAGE);
            } catch (Exception ee) {
                jop.showMessageDialog(this, ee.toString(), "Error", jop.ERROR_MESSAGE);
                System.err.println(ee);
                ee.printStackTrace();
                statusBar.setText("Error saving");
            }
        }
//	jlstGraphs.setListData(graphs.keySet().toArray());
//	System.out.println(graphs.keySet());
    }

}